/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/

class CenterColIter {
    // iterate over all columns from center to rim
    // works for both even and odd number of columns
    /* behaviour
       init(5); successive calls to next() return:
       --> 2, 3, 1, 4, 0

       init(6); successive calls to next() return:
       --> 3, 2, 4, 1, 5, 0
    */
    private static int offset = 0 ;
    private static int sign = 1 ;
    private static int columnNum = 0 ;
    private static int oddEven = 1 ;

    static public void init(int columnNum) {
      CenterColIter.columnNum = columnNum ;
      offset = 0 ;
      sign = -1 ;
      oddEven = ((columnNum/2)*2 == columnNum) ? -1 : +1 ;
    }

    static public int next() {
      // return next column to try, -1 when all tried
      int column = columnNum/2 + offset * sign * oddEven ;
      if (sign == -1)
        ++offset ;                 
      sign = -sign ;
      if (column <0 || column >= columnNum)
        column = -1 ;
      return column ;
    }
}