/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/

// show a log of lines to the user

// because the print() methods here are invoked from a thread outside Swing's main
// event loop (by the Robot.computeMove()), use invokeLater() to trigger the 
// display refresh after adding new text

import javax.swing.JTextArea ;
import javax.swing.SwingConstants ;
import javax.swing.SwingUtilities;

class GameLog extends JTextArea {
  
  StringBuffer buffer = new StringBuffer() ;  // StringBuffer is a synchronized class
  private static final int rows = 4 ;

  public GameLog() {
    setRows(rows) ;
    setEditable(false) ;
  }

  public void print(String s) {
    buffer.append(s) ;
  }   

  public void println(String s) {  // note that only the println methods cause a screen refresh
    buffer.append(s) ;
    buffer.append("\n") ;
    SwingUtilities.invokeLater(doAppend);
  }

  public void println() {
    println("") ;
  }


  final Runnable doAppend = new Runnable() {
    public void run() { 
      String s ;
      synchronized (buffer) {  // make sure this is atomic
        s = buffer.toString() ;
        buffer.setLength(0) ;
      }
      append(s) ;   // this triggers repaint() (I assume)
      setRows(rows) ;  // found necessary to make display regain four lines after resize
      setCaretPosition(getDocument().getLength()-1) ; // one less because of the trailing newline
    }
  };


}
  