/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/

// entry from for accepting human move

import javax.swing.JPanel; 
import javax.swing.JButton;
import java.awt.GridLayout;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener;

public class HumanMove extends JPanel {

  private final VierGewinntModel model ;
  private final JButton buttons[] ;

  public HumanMove(final VierGewinntModel model) {
    this.model = model ;
    model.registerHuman(this) ;
    JButton button;
    setLayout(new GridLayout(1, model.f.columnNum));
    buttons = new JButton[model.f.columnNum] ;
    for (int i=0; i<model.f.columnNum; ++i) {
      button = new JButton("" + (i+1)) ;
      buttons[i] = button ;
      add(button) ;
      button.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          int column = Integer.parseInt(e.getActionCommand())-1 ;
          disableButtons() ;
          model.humanMove(column) ;
        }
      }) ;
    }
    disableButtons() ;  // start with buttons disabled
  }

  private void disableButtons() {
    for (int i=0; i<model.f.columnNum; ++i) 
      buttons[i].setEnabled(false) ;  
  }

  public void waitForMove() {  // enable buttons
    for (int i=0; i<model.f.columnNum; ++i) 
      buttons[i].setEnabled(true) ;  
  }

}

